#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <errno.h>
#include <unistd.h>
#include <sys/select.h>
#include "sball.h"

#ifdef __FreeBSD__
#define DEFDEV	"/dev/ttyu0"
#else
#define DEFDEV	"/dev/ttyS0"
#endif

static void sighandler(int s);

static struct sball *sb;
static int quit;

int main(int argc, char **argv)
{
	int fd;
	fd_set rdset;

	signal(SIGINT, sighandler);

	if(!(sb = sball_open(argv[1] ? argv[1] : DEFDEV))) {
		fprintf(stderr, "Failed to open spaceball at %s\n", argv[1] ? argv[1] : DEFDEV);
		return 1;
	}
	fd = sball_fd(sb);

	printf("Monitoring device, ctrl-c to quit\n");

	while(!quit) {
		FD_ZERO(&rdset);
		FD_SET(fd, &rdset);

		if(select(fd + 1, &rdset, 0, 0, 0) > 0) {
			if(FD_ISSET(fd, &rdset)) {
				sball_read(sb);
			}
		}

	}
	putchar('\n');

	sball_close(sb);
	return 0;
}

static void sighandler(int s)
{
	quit = 1;
}
